require 'securerandom'

module InfluxDB
  module Rails
    class Rack # rubocop:disable Style/Documentation
      def initialize(app)
        @app = app
      end

      def call(env)
         al_request_guid = env["HTTP_AL_REQUEST_GUID"] || SecureRandom.uuid
         #al_request_id =  SecureRandom.uuid
         al_request_id =  SecureRandom.uuid
         al_source = "AL_NONE"
         al_request_client_id = "AL_NONE"

         Thread.current["al_request_id"] = al_request_id
         Thread.current["al_request_guid"] = al_request_guid
         Thread.current["al_source"] = env["HTTP_AL_SOURCE"] || al_source
         Thread.current["al_request_client_id"] = env["HTTP_AL_REQUEST_CLIENT_ID"] || al_request_client_id

         env["HTTP_AL_REQUEST_ID"] = al_request_id
         env["HTTP_AL_REQUEST_GUID"] = al_request_guid
        dup._call(env)
      end

      def _call(env)
        begin
          response = @app.call(env)
        rescue StandardError => e
          InfluxDB::Rails.transmit_unless_ignorable(e, env)
          raise(e)
        end

        response
      end
    end
  end
end
